<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Calibration</title>
    <style>
        body{
            background-color:black;
            overflow:hidden;
        }
        #star{
            opacity:1;
            position:absolute;
            width:100px;
            height:100px;
            top:calc(50% - 50px);
            left:calc(50% - 50px);
            border-radius:50%;
            transition: background-color 0.5s ease;

        }

        #star img{
            width:100%;
        }

        #complete{
            position:fixed;
            top:0;
            left:0;
            width:100vw;
            height:100vh;
            background-color: #6fff90;
            opacity:0;
            z-index:1;
        }

    </style>
</head>
<body>

<div id="star">
    <img src="star.png"/>
</div>

<div id="complete"></div>

<script src="http://localhost:5000/app/js/lodash/lodash.min.js"></script>
<script src="http://localhost:5000/app/js/Tone.js/Tone.min.js"></script>
<script
  src="https://code.jquery.com/jquery-3.4.1.min.js"
  integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo="
  crossorigin="anonymous"></script>

<script>


    let point = [];
    let gaze = [-1,-1];
    const tolerance = 0.3;
    let ended = false;
    let waiting = false;
    let timers = [];
    let firstPoint = true;
    let sound = {};


    function dist(point1, point2){
        let a = point1[0] - point2[0];
        let b = point1[1] - point2[1];
        return Math.sqrt( a*a + b*b );
    }

    function goToMenu(){
        let getUrl = window.location;
        let baseUrl = getUrl .protocol + "//" + getUrl.host
        let menuUrl = baseUrl+"/app/homepage/"
        window.location.replace(menuUrl);
    }

    function connect(){
        let trackerconnection = new WebSocket("ws://localhost:5001");
        trackerconnection.onopen = () => {
            trackerconnection.send(JSON.stringify({type:"room",data:"desktop"}));
            console.log("hello tracker!");
            setTimeout(()=>{
             trackerconnection.send(JSON.stringify({type:"start_calibration"}));
            },500);

            loadSound("richiamo.wav");
        }

        //on close
        trackerconnection.onclose = function (err) {
         console.log("bye tracker!", err);
            setTimeout(()=>{connect()}, 1000)
     };


         //on message
        trackerconnection.onmessage = (message) => {
            const msg = JSON.parse(message.data);
            switch(msg.type){
                case "end_calibration":
                    console.log("end_calibration");
                    $( "#star" ).animate({
                        opacity:0
                      }, 1000, function() {
                        $( "#complete" ).animate({
                        opacity:1
                      }, 1000)
                      });
                    waiting = false;
                    ended = true;
                    break;

                case "calibrate_point":
                    
                    timers.forEach((el)=>{
                        clearTimeout(el);
                    });
                    timers = [];

                    waiting = false;
                    console.log("star_dot")
                    
                    if(!firstPoint){
                        $("#star img").attr("src","star_dot.gif")
                        timers.push(setTimeout(()=>{
                            console.log("dot")
                            $("#star img").attr("src","dot.png")}, 1000));
                    }

                    point = msg.data;
                    console.log(msg);
                    
                    let newLeft = point[0]*window.innerWidth - 50;
                    let newTop = point[1]*window.innerHeight - 50;

                    if(!firstPoint) {
                        $( "#star" ).animate({
                            "left": newLeft,
                            "top": newTop
                          }, 3000, function() {
                            
                            console.log("dot_star");
                            $("#star img").attr("src","dot_star.gif");

                            timers.push(setTimeout(()=>{

                                waiting = true;
                                timers = [];
                                console.log("waiting for check");

                            },1000))

                          });
                    } else {
                        waiting = true;
                        firstPoint = false;
                    }
                    break;

                case "recalibrate":
                    console.log("recalibrate");
                    break;

                case "interrupt_calibration":
                    goToMenu();
                    break;

                case "gaze":
                    gaze = msg.data;

                    if(waiting) {

                        if(dist(gaze,point) < tolerance){
                            //$("#star").css({"background-color":"#3497ff"})
                            if(!timers.length) {

                                $("#star img").attr("src","star_pulse.gif");
                                playSound("richiamo.wav");
                                timers.push(setTimeout(()=>{
                                    console.log("star")
                                    trackerconnection.send(JSON.stringify({type:"calibration_point_in_position"}));
                                    waiting=false;
                                }, 700))
                            }                         

                        } else {
                            
                            console.log("too far: ", dist(gaze,point));
                            $("#star img").attr("src","star.png");
                            clearTimeout(timers[timers.length-1]);
                            timers = [];

                        }
                    }

                    break;

                default:
                    break
            }
        };

        //on error
        trackerconnection.onerror = function (err) {console.log("error tracker!", err)};
    }

    function loadSound(url) {

        sound = {   src: url, 
                    pl: new Tone.Player({   'url': url, 
                                            'autostart': false, 
                                            'loop': false}), 
                    gain: new Tone.Gain({gain: 1}).toMaster(), 
                    interval: undefined};

        sound.pl.connect(sound.gain);
    }

    function playSound(name){

        if(sound.pl.state !== 'started'){

            sound.gain.gain.value = 1;
            sound.pl.start();
        }
    }

    connect();

</script>
</body>
</html>